#include <stdio.h>
#include <iostream>
#include <string>

#include "manager.hh"
#include "stateSpace.hh"
#include "functions.hh"
#include "statistics.hh"
#include "utool.hh"

extern UCudd* ucudd;

void Manager::print_peakLiveNodeCount(cushort& indent, ostream& out) const {
  out << string(indent, ' ') << "Peak number of live nodes: " << PPRINT::tabularize(PPRINT::widthify(ucudd->ReadPeakLiveNodeCount())); }

void Manager::print(cushort& indent, ostream& out) const {
  out << string(indent, ' ') << "Statistics:" << endl;
  stats.print            (indent + 2, out);
  print_peakLiveNodeCount(indent + 2, out);
  out << endl; }

void Manager::print(const UBDD& result, cushort& indent, ostream& out) {
  bool print_it = true;
  if ( ! (result.empty() || result.full()))
    print_it = CONTROL::wait_yes_no("result BDD is neither Zero nor One; do you want to print it?");
  if (print_it) {
    out << "Resulting set of states:" << endl;
    if (! result.empty()) {
      out << "  "; S.print_header(out); out << endl
	  << endl; }
    result.enumerate(print_curr_S, UBDD::lines_per_page, out); }}

void Manager::print_decimal(const UBDD& result, ostream& out) const {
  ushort numbits = ucudd->ReadSize();
  char* C = new char[numbits];
  result.PickOneCube(C);
  int* state = new int [numbits]; // unfortunately, PickOneCube returns cube as char*, but we need int*
  for (ushort c = 0; c < numbits; ++c) {
    int i = C[c];
    state[c] = ( i < 2 ? i : 0 ); } // mapping '-' to 0
  delete C;
  S.print_decimal(state, UCudd::curr, out); // only pretty-print current states for now
  delete state; }
